# Условие: по колко начина можем да направим сума S, използвайки монетите от масив

# Памет NS
def coins2dArray(coins, sum):
	n = len(coins)
	answer = [ [0 for i in range(sum+1)] for i in range(n) ] # двумерната таблица с отговорите на подзадачите

	answer[0][coins[0]] = 1

	# има 1 начин да направим сума 0 с колкото и да е монети
	for i in range(n):
		answer[i][0] = 1

	for i in range(1,n):
		for j in range(1, sum+1):
			answer[i][j] = answer[i - 1][j]

			# понеже езика не е магически, трябва да проверим дали j - coins[i] не е отрицателно
			if j >= coins[i]:
				answer[i][j] += answer[i - 1][j - coins[i]]

	return answer[n - 1][sum]

# ако обхождаме сумите отзад напред, можем да се разминем само с 1 масив
# Памет S
def coins1dArray(coins, sum):
	answer = [0 for i in range(sum + 1)]
	answer[0] = 1

	for i in range(len(coins)):
		for j in range(sum, 0, -1): # от sum до 1 наобратно
			diff = j - coins[i]
			if diff >= 0:
				answer[j] += answer[diff]

	return answer[sum]

# решение с брутална сила за пълнота; показва и самите начини
# ако накараме другите решения също да показват самите суми, то тяхната сложност би 
# се увеличила до поне 2^N, защото от този порядък може да са възможните комбинации
# затова при задача от типа "колко начина" обикновено не се иска възстановяване
def bruteForce(coins, sum):
	n = len(coins)
	count = 0

	for selector in range(2**n):
		i = 0
		s = 0
		selected = []

		while selector > 0:
			if selector & 1 > 0:
				s += coins[i]
				selected.append(coins[i])
			i += 1
			selector >>= 1

		if s == sum:
			count += 1
			print(selected)

	return count

coins = [1,2,3,4,7,11,13,15]
targetSum = 23

print(coins2dArray(coins, targetSum))
print(coins1dArray(coins, targetSum))
print(bruteForce(coins, targetSum))
