# Условие: имаме матрица с числа. Можем да се движим надолу и надясно, като почваме
# от горен ляв ъгъл и искаме да стигнем до долен десен. Взимаме всички числа, през
# които минем. Каква е максималната сума, която можем да съберем?

LEFT = 0
UP = 1

def findMaxIterative(matrix):
	n = len(matrix)     # брой редове
	m = len(matrix[0])  # брой колони

	answer = [ [0 for x in range(m)] for x in range(n) ]
	where = [ [None for x in range(m)] for x in range(n) ] # за възстановяване

	answer[0][0] = matrix[0][0] # горен десен ъгъл
	# ако сега обработим тези ще пишем по-малко проверки по-нататък
	for i in range(1,m): # най-горния ред
		answer[0][i] = answer[0][i - 1] + matrix[0][i]
		where[0][i] = LEFT
	for i in range(1,n): # най-левия стълб
		answer[i][0] = answer[i - 1][0] + matrix[i][0]
		where[i][0] = UP

	for i in range(1,n):
		for j in range(1,n):
			if answer[i - 1][j] > answer[i][j - 1]:
				answer[i][j] = answer[i - 1][j] + matrix[i][j]
				where[i][j] = UP
			else:
				answer[i][j] = answer[i][j - 1] + matrix[i][j]
				where[i][j] = LEFT

	# възстановяване на пътя
	path = [ (n - 1, m - 1) ]
	i, j = n - 1, m - 1
	while (i, j) != (0, 0):
		if where[i][j] == LEFT:
			new = (i, j - 1)
			path.append(new)
			i, j = new			
		elif where[i][j] == UP:
			new = (i - 1, j)
			path.append(new)
			i, j = new
		else:
			print("error on where")
			break

	return answer[n - 1][m - 1], path[::-1]

# ако мажем по входа, може да се разминем с константна памет
def findMaxIterativeConstantMemory(matrix):
	n = len(matrix)     # брой редове
	m = len(matrix[0])  # брой колони

	# ползваме matrix като answer
	for i in range(1,m):
		matrix[0][i] += matrix[0][i - 1]
	for i in range(1,n):
		matrix[i][0] += matrix[i - 1][0]

	for i in range(1,n):
		for j in range(1,m):
			matrix[i][j] += max(matrix[i - 1][j], matrix[i][j - 1])

	return matrix[n - 1][m - 1]

# ако искаме рекурсията да измисли в какъв ред да ги смята
# така решението на задачата почти веднага излиза от рекурсивната дефиниция
# за отговора на подзадачите
def findMaxRec(matrix, answer, row, column):
	if answer[row][column] != None: 
		return answer[row][column] # мемоизация

	if row == 0:
		answer[row][column] = matrix[row][column] + findMaxRec(matrix, answer, row, column - 1)
	elif column == 0:
		answer[row][column] = matrix[row][column] + findMaxRec(matrix, answer, row - 1, column)
	else:
		answer[row][column] = matrix[row][column] + max(findMaxRec(matrix, answer, row - 1, column), 
														findMaxRec(matrix, answer, row, column - 1))
	return answer[row][column]

# инициализация на рекурсията
def findMaxRecStart(matrix):
	n = len(matrix)     # брой редове
	m = len(matrix[0])  # брой колони

	answer = [ [None for x in range(m)] for i in range(n) ]
	answer[0][0] = matrix[0][0]

	return findMaxRec(matrix, answer, n - 1, m - 1)

matrix = [ [ 10, 15, 11, 4, 24 ],
[ 6, 10, 18, 12, 3 ],
[ 3, 15, 13, 22, 25 ],
[ 6, 17, 2, 29, 18 ],
[ 28, 3, 30, 17, 16 ] ]

maxSum, path = findMaxIterative(matrix)
print(maxSum)
print(path)

maxSum = findMaxRecStart(matrix)
print(maxSum)

maxSum = findMaxIterativeConstantMemory(matrix)
print(maxSum)